dnl macros for DCC autoconf

dnl Rhyolite Software DCC 1.2.29-1.78 $Revision$

AC_DEFUN(LSC_SENDMAIL,[
# Look for sendmail
#	dccm requires the sendmail milter header file and library.
#	Without an explicit hint in the SENDMAIL environment variable,
#	look for them first in a sendmail directory parallel to the DCC
#	source directory.
AC_ARG_WITH(sendmail,
[  --with-sendmail=DIR	build dccm with sendmail milter interface in dir])dnl
if test "$enable_dccm" = no -o "$with_sendmail" = no -o ! -d dccm; then
    with_sendmail=no
    enable_dccm=no
    SENDMAIL=no
    SENDMAIL_OBJ=/dev/null
    SENDMAIL_LIB=/usr/lib
else
    SENDMAIL_OBJ=
    SENDMAIL_LIB=
fi
if test ! -z "$with_sendmail" -a "$with_sendmail" != yes -a "$with_sendmail" != no; then
    SENDMAIL="$with_sendmail"
    SENDMAIL_EVAL="$SENDMAIL"
    with_sendmail=yes
fi
if test -z "$SENDMAIL"; then
    # prefer a parallel ../sendmail directory
    DEPTH=.
    SENDMAIL='${DEPTH}/../sendmail'
    eval SENDMAIL_EVAL=$SENDMAIL
    # notice native installation on Freebsd 4.6 and elsewhere
    if test ! -d $SENDMAIL_EVAL						\
	    -a -f /usr/include/libmilter/mfapi.h			\
	    -a -f /usr/lib/libmilter.a; then				\
	SENDMAIL=/usr/include
	SENDMAIL_EVAL=$SENDMAIL
	SENDMAIL_OBJ=/usr/lib
	SENDMAIL_OBJ_EVAL=$SENDMAIL_OBJ
	SENDMAIL_LIB=$SENDMAIL_OBJ/libmilter.a
    fi
    # notice a FreeBSD sendmail package if there is only one
    if test ! -d $SENDMAIL_EVAL						\
	    -a "$TARGET_SYS" = FreeBSD; then				\
	SENDMAIL_PKG=`echo /usr/ports/mail/sendmail/work/sendmail*`
	if test -d "$SENDMAIL_PKG"; then
	    SENDMAIL="$SENDMAIL_PKG"
	    SENDMAIL_EVAL="$SENDMAIL"
	fi
    fi
    # notice native installation on some versions of NetBSD
    if test ! -d $SENDMAIL_EVAL						\
	    -a -f /usr/pkg/include/libmilter/mfapi.h			\
	    -a -f /usr/pkg/lib/libmilter.a				\
	    -a "$TARGET_SYS" = NetBSD; then				\
	SENDMAIL=/usr/pkg/include
	SENDMAIL_EVAL=$SENDMAIL
	SENDMAIL_OBJ=/usr/pkg/lib
	SENDMAIL_OBJ_EVAL=$SENDMAIL_OBJ
	SENDMAIL_LIB=$SENDMAIL_OBJ/libmilter.a
    fi
    # notice native installation on some flavors of Linux
    if test ! -d $SENDMAIL_EVAL						\
	    -a -f /usr/include/libmilter/mfapi.h			\
	    -a -f /usr/lib/libmilter/libmilter.a			\
	    -a "$TARGET_SYS" = Linux; then				\
	SENDMAIL=/usr/include
	SENDMAIL_EVAL=$SENDMAIL
	SENDMAIL_OBJ=/usr/lib/libmilter
	SENDMAIL_OBJ_EVAL=$SENDMAIL_OBJ
	SENDMAIL_LIB=$SENDMAIL_OBJ/libmilter.a
    fi
fi
# look for a standard sendmail object directory if we still lack libmilter.a
if test -z "$SENDMAIL_LIB"; then
    case "$TARGET_SYS" in
    AIX)
	# sendmail thinks all AIX systems are "PPC"
	PLATFORM=`uname -vs | tr ' /' '.\-'`.`uname -r`.PPC;;
    SunOS)
	# sendmail does not like the trailing 'u' in sun4u
	PLATFORM=`uname -rsm | tr ' /' '.\-' | sed -e 's/sun4u$/sun4/'`;;
    *)
	PLATFORM=`uname -rsm | tr ' /' '.\-'`;;
    esac
    SENDMAIL_OBJ="$SENDMAIL/obj.$PLATFORM"
    SENDMAIL_LIB="$SENDMAIL_OBJ/libmilter/libmilter.a"
    # add the odd old sendmail 8.11 milter extra library
    eval SENDMAIL_OBJ_EVAL="\"$SENDMAIL_OBJ\""
    if test -f "$SENDMAIL_OBJ_EVAL/libsmutil/libsmutil.a"; then
	SENDMAIL_LIB="$SENDMAIL_LIB $SENDMAIL_OBJ/libsmutil/libsmutil.a"
    fi
    # and the odd libsm.a that 8.12.1 needs for sm_printf()
    if test -f "$SENDMAIL_OBJ_EVAL/libsm/libsm.a"; then
	SENDMAIL_LIB="$SENDMAIL_LIB $SENDMAIL_OBJ/libsm/libsm.a"
    fi
fi
AC_SUBST(SENDMAIL)dnl
AC_SUBST(SENDMAIL_LIB)dnl
])


AC_DEFUN(LSC_IPV6,[dnl
# Decide whether we should try to build IPv6 support.  Be conservative
#	and give up at the first sign of trouble.
AC_ARG_ENABLE(IPv6,
[  --disable-IPv6	no IPv6 support])dnl
# some systems think they have IPv6 but don't or have odd definitions
#   for the structure tags
case "$TARGET_SYS" in
    SunOS)
	AC_DEFINE(CONF_S6_ADDR32,_S6_un._S6_u32)dnl
#	use poll() instead of select() on Solaris because socket() can yield
#	file descriptors larger than FD_SETSIZE
	AC_DEFINE(USE_POLL,1)dnl
	;;
    OSF1)
	AC_DEFINE(CONF_S6_ADDR32,s6_laddr)dnl
	;;
    OpenUNIX)
	enable_IPv6=no
	AC_DEFINE(CONF_S6_ADDR32,S6_un.S6_l)dnl
	;;
    *)
	AC_DEFINE(CONF_S6_ADDR32,__u6_addr.__u6_addr32)dnl
	;;
esac
if test "$enable_IPv6"SET = noSET -o "$enable_IPV6"SET = noSET	\
	-o "$enable_ipv6"SET = noSET; then
    NO_IPV6="disabled"
    unset ac_cv_getipnodebyname
else
    AC_CHECK_FUNC(getipnodebyname, , NO_IPV6="no getipnodebyname()")dnl
fi
AC_MSG_CHECKING([for IPv6])
AC_EGREP_HEADER([sockaddr_in6], netinet/in.h, ,
    NO_IPV6="no sockaddr_in6")dnl
AC_EGREP_HEADER([in6_addr], netinet/in.h, ,
    NO_IPV6="no in6_addr")dnl
dnl if AF_INET6 is defined, it won't appear in the cpp output
AC_EGREP_CPP([^AF_INET6$], [#include<sys/socket.h>
AF_INET6],
    NO_IPV6="no AF_INET6"
    AC_DEFINE(NO_AF_INET6))
if test "X$NO_IPV6" = X; then
    AC_MSG_RESULT(yes)
else
    AC_MSG_RESULT($NO_IPV6)
    AC_DEFINE_UNQUOTED(NO_IPV6, "$NO_IPV6")dnl
fi
])


# check for 4.4BSD sockets
AC_DEFUN(LCS_SOCKETS,[dnl
AC_BEFORE([$0], [LCS_GETIFADDRS])dnl
# look for sockets with lengths
AC_CACHE_CHECK([for sa_len],ac_cv_have_sa_len,[dnl
    AC_EGREP_HEADER(changequote(<<,>>)<<[^_]sa_len[^_a-z0-9]>>changequote([,]),
	sys/socket.h,dnl
	ac_cv_have_sa_len=yes,ac_cv_have_sa_len=no)])
if test "$ac_cv_have_sa_len" = yes; then
    AC_DEFINE(DCC_HAVE_SA_LEN)dnl
fi
# many systems want recvfrom() to use a pointer to a socklen_t
AC_CACHE_CHECK([for socklen_t],ac_cv_have_socklen_t,[dnl
    AC_EGREP_HEADER(changequote(<<,>>)<<typedef.*[^_]socklen_t[^_a-z0-9]>>changequote([,]),
	sys/socket.h,dnl
	ac_cv_have_socklen_t=yes,ac_cv_have_socklen_t=no)])
if test "$ac_cv_have_socklen_t" = yes; then
    AC_DEFINE(DCC_HAVE_SOCKLEN_T)dnl
fi
# some systems have broken UDP connectioned sockets
AC_MSG_CHECKING([for connected UDP sockets])
case "$TARGET_SYS" in
    BSD/OS|FreeBSD|SunOS|IRIX*|OpenBSD|NetBSD)
	AC_DEFINE(DCC_UDP_DISCON,0)dnl
	AC_MSG_RESULT([yes])
	;;
    Linux)
				# RedHat 6.0 & newer work in the Linux Way,
				#   but older versions don't even do that
	UNAME_R=`uname -r`
	UNAME_R_MAJ=`expr "$UNAME_R" : '\([[0-9]]*\)\..*'`
	UNAME_R_MIN=`expr "$UNAME_R" : '[[0-9]]*\.\([[0-9]]*\)\..*'`
	if test `expr $UNAME_R_MAJ \* 100 + $UNAME_R_MIN` -ge 202; then
	    AC_DEFINE(DCC_UDP_DISCON,sizeof(ctxt->conn_su.sa))dnl
	    AC_MSG_RESULT([yes])
	else
	    AC_MSG_RESULT([no])
	fi
	;;
    AIX|OpenUNIX)		# AIX and OpenUNIX do not work.
	AC_MSG_RESULT([no]);;
    *)				# be conservative the rest of the time
	AC_MSG_RESULT([no]);;
esac])


# deal with getifaddrs()
AC_DEFUN(LCS_GETIFADDRS,[dnl
AC_CHECK_FUNCS(getifaddrs)dnl
if test "$ac_cv_func_getifaddrs" = yes; then
    AC_CHECK_FUNCS(freeifaddrs)dnl
else
    AC_CACHE_CHECK([getifaddrs replacement],ac_cv_use_dcc_getifaddrs,[dnl
    OLD_CFLAGS="$CFLAGS"
    CFLAGS="$CFLAGS -I include"
    AC_TRY_COMPILE([#define TEST_DCC_GETIFADDRS
#include "dcclib/getifaddrs.c"],,
	ac_cv_use_dcc_getifaddrs=yes,ac_cv_use_dcc_getifaddrs=no)])
    CFLAGS="$OLD_CFLAGS"
    if test "$ac_cv_use_dcc_getifaddrs" = yes; then
	AC_DEFINE(USE_DCC_GETIFADDRS)dnl
    fi
fi
])


AC_DEFUN(LCS_OFF_T_SIZE,[
# does this system have 64 bit file offsets?
AC_CACHE_CHECK([sizeof(off_t)],ac_cv_sizeof_off_t,[dnl
AC_TRY_RUN([#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
main()
{
  FILE *f=fopen("conftestval", "w");
  if (!f) exit(1);
  fprintf(f, "%d\n", sizeof(off_t));
  exit(0);
}],
ac_cv_sizeof_off_t=`cat conftestval`,
ac_cv_sizeof_off_t=4,
ac_cv_sizeof_off_t=4)])
if test 0$ac_cv_sizeof_off_t -eq 8; then
    AC_DEFINE(HAVE_BIG_FILES)dnl
fi])


AC_DEFUN(LCS_RUNDIR,[
# where is a good place to put the dccm and dccifd sockets and PID files?
AC_ARG_WITH(rundir,
[  --with-rundir=DIR	for PID files and milter socket])dnl
dcc_rundir=/var/run/dcc
if test ! -z "$with_rundir"; then
    unset ac_cv_path_varrun
    dcc_rundir="$with_rundir"
else
    AC_CACHE_CHECK([run directory],ac_cv_path_varrun,[dnl
    AC_TRY_RUN([#include <stdio.h>
#include "include/dcc_paths.h"
main()
{
    FILE *f=fopen("conftestval", "w");
    if (!f) exit(1);
    fprintf(f, _PATH_VARRUN"\n");
    exit(0);
}],
    x=`cat conftestval`; ac_cv_path_varrun=`expr "$x" \: '\(.*\)/$' \| "$x"`,
    ac_cv_path_varrun=/var/run,ac_cv_path_varrun=/var/run)])
    dcc_rundir=$ac_cv_path_varrun/dcc
fi
AC_DEFINE_UNQUOTED(DCC_RUNDIR,"$dcc_rundir")dnl
AC_SUBST(dcc_rundir)])


AC_DEFUN(LCS_MD5,[dnl
# Try to use a local md5.h and md5.c.  Some systems such as RedHat 7.3
#   have versions of /usr/include/md5.h that are not directly usable.
#   Then there are the odd versions that are installed on systems.
AC_ARG_WITH(supplied-MD5,
[  --with-DCC-MD5	use MD5 code in the DCC source])dnl
if test "$with_DCC_MD5"SET = yesSET; then
    unset ac_cv_header_md5_h
    unset ac_cv_search_MD5Init
else
    AC_CHECK_HEADER(md5.h,
	AC_TRY_COMPILE([#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/param.h>
#include <md5.h>],[],
	AC_SEARCH_LIBS(MD5Init, md md5, AC_DEFINE(HAVE_MD5),
	    ac_cv_header_md5_h=no),
	AC_MSG_RESULT([md5.h does not compile]); ac_cv_header_md5_h=no))dnl
fi])



AC_DEFUN(LCS_RLIMIT,[
# does this system have getrlimit()?
AC_CHECK_FUNCS(getrlimit)dnl
if test "$ac_cv_func_getrlimit" = yes; then
    AC_CACHE_CHECK([for RLIMIT_NOFILE],ac_cv_rlimit_nofile,[dnl
    AC_EGREP_CPP(yes,
[#include <sys/resource.h>
#ifdef RLIMIT_NOFILE
  yes
#endif], ac_cv_rlimit_nofile=yes, ac_cv_rlimit_nofile=no)])
    if test "$ac_cv_rlimit_nofile" = yes; then
	AC_DEFINE(HAVE_RLIMIT_NOFILE)dnl
    fi
fi])


AC_DEFUN(LCS_MEMSIZE,[
# How can we discover the size of physical memory?
GOT_PHYSMEM=
dnl # prefer physmem_total() someday if available
dnl but not until tested AC_CHECK_FUNCS(physmem_total,[GOT_PHYSMEM=yes; break])
# Solaris sysconf()
if test -z "$GOT_PHYSMEM"; then
    AC_CACHE_CHECK([for sysconf(_SC_PHYS_PAGES)+sysconf(_SC_PAGESIZE)],
	ac_cv_have_sysconf_pages,[dnl
    AC_TRY_COMPILE([#include <unistd.h>],
	[sysconf(_SC_PHYS_PAGES)+sysconf(_SC_PAGESIZE)],
	ac_cv_have_sysconf_pages=yes,ac_cv_have_sysconf_pages=no)])
    if test "$ac_cv_have_sysconf_pages" = yes; then
	GOT_PHYSMEM=sysconf
	AC_DEFINE(HAVE__SC_PHYS_PAGES)dnl
    fi
fi
# BSD sysctl()
if test -z "$GOT_PHYSMEM"; then
    AC_CACHE_CHECK([for sysctl(HW_PHYSMEM)],
	ac_cv_have_hw_physmem,[dnl
    AC_TRY_COMPILE([#include <sys/types.h>
	#include <sys/param.h>
	#include <sys/sysctl.h>],
	[sysctl(0,HW_PHYSMEM,0,0,0,0)],
	ac_cv_have_hw_physmem=yes,ac_cv_have_hw_physmem=no)])
    if test "$ac_cv_have_hw_physmem" = yes; then
	GOT_PHYSMEM=sysctl
	AC_DEFINE(HAVE_HW_PHYSMEM)dnl
    fi
fi])



AC_DEFUN(LCS_PROG_CC,[
# how do we run the C compiler?
AC_BEFORE([$0], [LSC_MAKE_INCS])dnl
HAVE_CC_M='#do not have cc -M'
LIBS="$LIBS -lm"
RANLIB="ranlib"
case "$TARGET_SYS" in
    BSD/OS)
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -pthread"
	;;
    FreeBSD)
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -pthread"
	PTHREAD_LIBS="$PTHREAD_LIBS -lc_r"
	;;
    SunOS)
	DCC_CFLAGS="-D_REENTRANT $DCC_CFLAGS"
	PTHREAD_LIBS="$PTHREAD_LIBS -lpthread"
	LIBS="$LIBS -lsocket -lnsl -lresolv"
	;;
    HP-UX)
	PTHREAD_LIBS="$PTHREAD_LIBS -lpthread"
	;;
    AIX)
	AC_AIX dnl
	DCC_CFLAGS="-D_THREAD_SAFE $DCC_CFLAGS"
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -pthread"
	PTHREAD_LIBS="$PTHREAD_LIBS -lpthreads"
	LIBS="$LIBS -lbsd -lc_r"
	;;
    IRIX*)
	PTHREAD_LIBS="$PTHREAD_LIBS -lpthread"
	DCC_CFLAGS="-woff 1185 $DCC_CFLAGS"
	CFLAGS="-woff 1185 $CFLAGS"
	DCC_LDFLAGS="-LD_MSG:OFF=84 $DCC_LDFLAGS"
	RANLIB="@#ranlib"
	HAVE_CC_M='HAVE_CC_M=yes'
	;;
    Linux|OpenBSD)
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -pthread"
	;;
    NetBSD)
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -lpthread"
	PTHREAD_CFLAGS="$PTHREAD_CFLAGS -I/usr/pkg/include"
	CPPFLAGS="$CPPFLAGS -I/usr/pkg/include"
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -L/usr/pkg/lib"
	;;
    OSF1)
	# OSF1 is too messy for AC_CHECK_FUNC(pthread_mutex_lock...)
	have_pthreads=yes
	PTHREAD_CFLAGS="$PTHREAD_CFLAGS -pthread -D_REENTRANT"
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -pthread"
	PTHREAD_LIBS="$PTHREAD_LIBS -lpthread -lexc"
	HAVE_CC_M='HAVE_CC_M=yes'
	;;
    OpenUNIX)
	DCC_CFLAGS="-Kthread $DCC_CFLAGS"
	PTHREAD_LIBS="$PTHREAD_LIBS -Kthread"
	LIBS="$LIBS -lsocket -lnsl"
	RANLIB="@#ranlib"
	;;
    *)
	AC_MSG_RESULT([	*** unrecognized system $TARGET_SYS ***])
	AC_PROG_RANLIB
	if test "$RANLIB" = ':'; then
	    RANLIB="@#ranlib"
	fi
	PTHREAD_LDFLAGS="$PTHREAD_LDFLAGS -pthread"
	;;
esac
if test "$have_pthreads" != yes; then
    OLD_CFLAGS="$CFLAGS"
    CFLAGS="$CFLAGS $PTHREAD_CFLAGS"
    OLD_LDFLAGS="$LDFLAGS"
    LDFLAGS="$LDFLAGS $PTHREAD_LDFLAGS"
    OLD_LIBS="$LIBS"
    LIBS="$LIBS $PTHREAD_LIBS"
    AC_CHECK_FUNC(pthread_mutex_lock,have_pthreads=yes)dnl
    CFLAGS="$OLD_CFLAGS"
    LDFLAGS="$OLD_LDFLAGS"
    LIBS="$OLD_LIBS"
fi
AC_EGREP_CPP([^MS_ASYNC$], [#include <sys/mman.h>
MS_ASYNC], AC_DEFINE(HAVE_OLD_MSYNC, ))dnl
AC_SUBST(DCC_CFLAGS)dnl
AC_SUBST(DCC_LDFLAGS)dnl
AC_SUBST(PTHREAD_CFLAGS)dnl
AC_SUBST(PTHREAD_LDFLAGS)dnl
AC_SUBST(PTHREAD_LIBS)dnl
AC_SUBST(RANLIB)dnl

AC_CACHE_CHECK([for gcc __attribute__],ac_cv_have_gcc_attributes,[dnl
AC_TRY_COMPILE(,[extern void __attribute((noreturn)) ck(); ck();],
    ac_cv_have_gcc_attributes=yes,ac_cv_have_gcc_attributes=no)])
if test "$ac_cv_have_gcc_attributes" = yes; then
    CWARN="CWARN"
    HAVE_CC_M='HAVE_CC_M=yes'
    AC_DEFINE(HAVE_GCC_ATTRIBUTES)dnl
    AC_DEFINE(HAVE_GCC_INLINE)dnl
else
    CWARN="#CWARN"
fi
AC_SUBST(CWARN)dnl
AC_SUBST(HAVE_CC_M)dnl
])


AC_DEFUN(LSC_MAKE_INCS,[
# set switches to generate the meat of a makefile
AC_MSG_CHECKING([for gmake])
if make -v nosuchtarget 2>&1 | grep '^GNU Make' >/dev/null; then
    DCCMAKE=gmake
    AC_MSG_RESULT([yes])
else
    if test -f /usr/share/mk/bsd.prog.mk; then
	DCCMAKE=make
	AC_MSG_RESULT([no, assume 4.4BSD make])
    else
	AC_MSG_RESULT([	*** You must use gmake ***])
	DCCMAKE=gmake
    fi
fi
DEPTH=.
if test "$DCCMAKE" = gmake; then
    MAKE_DOT=
    MAKE_INC='#include "${DEPTH}/Makefile.inc"'
    MAKE_INC2='include ${DEPTH}/Makefile.inc2'
    MAKE_PROG='include ${DEPTH}/gmake.inc'
    MAKE_SUBDIR='include ${DEPTH}/gmake.inc'
    MAKE_LIB='include ${DEPTH}/gmake.inc\
include ${DEPTH}/Makefile.inc2'
else
    MAKE_DOT="."
    MAKE_INC='.include "${DEPTH}/Makefile.inc"'
    MAKE_INC2='.include "${DEPTH}/Makefile.inc2"'
    MAKE_PROG='.include <bsd.prog.mk>'
    if test "$TARGET_SYS" = 'NetBSD'; then
	MAKE_SUBDIR='.include <bsd.subdir.mk>'
    else
	MAKE_SUBDIR='.include <bsd.prog.mk>'
    fi
    MAKE_LIB='.include <bsd.lib.mk>'
fi
AC_SUBST(MAKE_INC)dnl
AC_SUBST(MAKE_INC2)dnl
AC_SUBST(MAKE_PROG)dnl
AC_SUBST(MAKE_SUBDIR)dnl
AC_SUBST(MAKE_LIB)dnl
AC_SUBST(MAKE_DOT)dnl
])


dnl It seems like a bug that $prefix is not set to $ac_default_prefix
dnl	until after all definitions are handled.
AC_DEFUN(LSC_DEFAULT_DIRS,[
# Decide about man pages and what to build
if test "$prefix" = NONE; then
    if test -z "$DCC_HOMEDIR"; then
	DCC_HOMEDIR=$ac_default_prefix
    fi
    prefix=$DCC_HOMEDIR
fi
AC_DEFINE_UNQUOTED(DCC_HOMEDIR,"$prefix")dnl
if test "$libexecdir" = '${exec_prefix}/libexec'; then
    libexecdir=$prefix/libexec
fi
AC_DEFINE_UNQUOTED(DCC_LIBEXECDIR,"$libexecdir")dnl
if test "$bindir" = '${exec_prefix}/bin'; then
    if test "$enable_sys_inst" = no -a ! -w /usr/local/bin -a -d $HOME/bin; then
	bindir=$HOME/bin
	AC_MSG_RESULT([install binaries in $bindir])
    else
	bindir=/usr/local/bin
    fi
fi

# default cgibin after prefix has been figured out
if test -z "$cgibin"; then
    cgibin="$prefix/cgi-bin"
fi
AC_SUBST(cgibin)dnl

# Pick the default target location of the man pages and
#	decide whether to generate .8 or .0 files.
case "$TARGET_SYS" in
    Linux)
	# default to /usr/local/man/man8 and use roff files
	mancat=man
	MAN8='dcc.8 $(SUBDIR_MAN8)'
	MAN8INST=''
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    OpenBSD)
	# default to /usr/local/man/cat8 and wahtever.0 names
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST=''
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    HP-UX)
	# default to /usr/local/man/cat8 and use cleartext files and
	#   whatever.8 names
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST='/`expr $$NM : "\(.*\)".0`.8'
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    IRIX*)
	# default to /usr/local/man/man8 and use cleartext files and
	#   whatever.8 names
	mancat=man
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST='/`expr $$NM : "\(.*\)".0`.8'
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    SunOS)
	# default to /usr/local/man/cat8 and use cleartext files,
	#   use our installation rule, and whatever.8 names
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST='/`expr $$NM : "\(.*\)".0`.8'
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    FreeBSD)
	# default to /usr/local/man/man8 and use nroff files, possibly
	#   compressed via /usr/share/mk
	mancat=man
	MAN8='dcc.8 $(SUBDIR_MAN8)'
	MAN8INST=''
	USE_DCCMANINSTALL='# do not use dccmaninstall'
	;;
    NetBSD)
	# default to /usr/local/man/man8 and use nroff files, possibly
	#   compressed via /usr/share/mk on versions well after 1.4.2.
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST=''
	# force NetBSD to install the man pages
	USE_DCCMANINSTALL='install maninstall: dccmaninstall'
	;;
    BSD/OS)
	# default to /usr/local/man/cat8 and use cleartext files, possibly
	#   compressed via /usr/share/mk, and named whatever.0
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST=''
	USE_DCCMANINSTALL='# do not use dccmaninstall'
	;;
    AIX)
	# default to /usr/local/man/cat8, use our installation rule,
	#   and use cleartext files named whatever.8
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST='/`expr $$NM : "\(.*\)".0`.8'
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    OpenUNIX)
	# default to /usr/local/man/cat8 and use cleartext files named
	#   whatever.8
	mancat=cat
	MAN8='dcc.0 $(SUBDIR_MAN0)'
	MAN8INST='/`expr $$NM : "\(.*\)".0`.8'
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
    *)
	AC_MSG_RESULT([	*** Cannot install man pages on unfamiliar systems ***])
	USE_DCCMANINSTALL='maninstall:dccmaninstall'
	;;
esac
if test "$mandir" = '${prefix}/man'; then
    if test "$DCC_MANDIR"SET != SET; then
	mandir="$DCC_MANDIR"
    else
	mandir=/usr/local/man
    fi
fi
mandir="$mandir/$mancat"
AC_SUBST(MAN8)dnl
AC_SUBST(MAN8INST)dnl
AC_SUBST(USE_DCCMANINSTALL)dnl

# Enough systems have idiosyncratic native install programs and we install
#   few enough files that it is usually best to use the autoconf script.
#   A few systems cannot tolerate the autoconf script.
case "$TARGET_SYS" in
    CYGWIN*)
	DCCINSTALL=install
	;;
    *)
	DCCINSTALL='${DEPTH}/autoconf/install-sh -c'
# some systems do not have UNIX file permissions
	AC_DEFINE(HAVE_PRIVATE_FILES)dnl
	;;
esac
AC_SUBST(DCCINSTALL)dnl

if test "$enable_dccifd" = no; then
    SUBDIR_DCCIFD=
else
    if test "$have_pthreads" = yes; then
	SUBDIR_DCCIFD=dccifd
    else
	AC_MSG_RESULT([	*** cannot build dccifd without threads ***])
    fi
fi
AC_SUBST(SUBDIR_DCCIFD)dnl

if test "$enable_server" = no -o "$enable_dccd" = no; then
    SUBDIR_DCCD=
    SUBDIR_SRVRLIB=
else
    SUBDIR_DCCD="dbclean dccd dblist"
    SUBDIR_SRVRLIB="srvrlib"
fi
AC_SUBST(SUBDIR_DCCD)dnl
AC_SUBST(SUBDIR_SRVRLIB)dnl

# We have already chosen the sendmail source directory.  Here we only
#	check that the milter library is present and turn dccm on or off.
SUBDIR_DCCM=
if test "$with_sendmail"SET != noSET -a "$enable_dccm"SET != noSET; then
    AC_MSG_RESULT([look for sendmail milter library in $SENDMAIL_OBJ_EVAL])
    if test ! -d $SENDMAIL_OBJ_EVAL; then
	AC_MSG_RESULT([	*** cannot build dccm without sendmail headers in $SENDMAIL_EVAL
		and libraries in $SENDMAIL_OBJ_EVAL ***])
    else
	if test "$have_pthreads" = yes; then
	    SUBDIR_DCCM=dccm
	else
	    AC_MSG_RESULT([	*** cannot build dccm without threads ***])
	fi
    fi
# If dccm has been installed but there is no sendmail library,
# then assume something is recently broken and try to build dccm regardless.
# This prevents bad things like losing a sendmail directory from letting
# a DCC build appear to succeed.
    if test -x "$libexecdir/dccm"; then
	if test -z "$SUBDIR_DCCM"; then
	    AC_MSG_RESULT([	*** try to rebuild dccm because it is already installed ***])
	fi
	SUBDIR_DCCM=dccm
    fi
fi
AC_SUBST(SUBDIR_DCCM)dnl
if test -z "$SUBDIR_DCCM"; then
    CONF_DCCM_ENABLE=off
else
    CONF_DCCM_ENABLE=on
fi
AC_SUBST(CONF_DCCM_ENABLE)dnl
if test -z "$SUBDIR_DCCM$SUBDIR_DCCIFD"; then
    SUBDIR_THRLIB=
else
    SUBDIR_THRLIB=thrlib
fi
AC_SUBST(SUBDIR_THRLIB)dnl
])
